import numpy as np
import matplotlib.pyplot as plt

prob1 = np.load('prob1.npy')
lower1 = np.load('lower1.npy')
upper1 = np.load('upper1.npy')
prob2 = np.load('prob2.npy')
lower2 = np.load('lower2.npy')
upper2 = np.load('upper2.npy')
prob3 = np.load('prob3.npy')
lower3 = np.load('lower3.npy')
upper3 = np.load('upper3.npy')
prob4 = np.load('prob4.npy')
lower4 = np.load('lower4.npy')
upper4 = np.load('upper4.npy')


prob1 = smooth(prob1, 50)
prob2 = smooth(prob2, 50)
prob3 = smooth(prob3, 50)
prob4 = smooth(prob4, 50)


def smooth(data, window):
    average_data = []
    for ind in range(len(data) - window + 1):
        average_data.append(np.mean(data[ind:ind + window]))
    for ind in range(window - 1):
        average_data.append(data[len(data) - window + ind + 1])
    return average_data


def make_plot(prob1, prob2, prob3, prob4, lower1, lower2, lower3, lower4, upper1, upper2, upper3, upper4):
    fig, (ax_coverage, ax_length) = plt.subplots(1, 2, figsize=(10, 4))
    plt.rcParams['text.usetex'] = True
    plt.rcParams['font.family'] = 'serif'
    ax_coverage.set_xscale('log')
    ax_length.set_xscale('log')
    ax_coverage.set_yticks([0.8, 0.85, 0.9, 0.95])
    ax_coverage.plot(np.arange(len(prob1)), prob1,  label='Coverage = 0.95', linewidth=2.5)
    ax_coverage.plot(np.arange(len(prob2)), prob2, label='Coverage = 0.9', linewidth=2.5)
    ax_coverage.plot(np.arange(len(prob3)), prob3, label='Coverage = 0.85', linewidth=2.5)
    ax_coverage.plot(np.arange(len(prob4)), prob4, label='Coverage = 0.8', linewidth=2.5)
    ax_coverage.set_xlabel('Number of iterations '+r'$(k)$', fontsize=16)
    ax_coverage.set_ylabel('Empirical Coverage', fontsize=16)
    ax_coverage.axhline(y=0.95, color='k', linestyle='dashdot', linewidth=1.5)
    ax_coverage.axhline(y=0.9, color='k', linestyle='dashdot', linewidth=1.5)
    ax_coverage.axhline(y=0.85, color='k', linestyle='dashdot', linewidth=1.5)
    ax_coverage.axhline(y=0.8, color='k', linestyle='dashdot', linewidth=1.5)
    ax_coverage.grid(axis='x', color='0.95', which="both")

    ax_length.plot(np.arange(len(prob1)), smooth(upper1 - lower1, 50), label='Coverage = 0.95', linewidth=2.5)
    ax_length.plot(np.arange(len(prob2)), smooth(upper2 - lower2, 50), label='Coverage = 0.9', linewidth=2.5)
    ax_length.plot(np.arange(len(prob3)), smooth(upper3 - lower3, 50), label='Coverage = 0.85', linewidth=2.5)
    ax_length.plot(np.arange(len(prob4)), smooth(upper4 - lower4, 50), label='Coverage = 0.8', linewidth=2.5)
    ax_length.set_xlabel('Number of iterations '+r'$(k)$', fontsize=16)
    ax_length.set_ylabel('Prediction interval length', fontsize=16)
    plt.subplots_adjust(top=0.9)
    Line, Label = ax_length.get_legend_handles_labels()
    lines = []
    labels = []
    lines.extend(Line)
    labels.extend(Label)
    fig.legend(lines, labels, loc = 'upper center', bbox_to_anchor=(0.5, 1.00),
           ncol=4, fancybox=True, shadow=True, fontsize=10)
    ax_length.grid(axis='x', color='0.95', which="both")

    plt.show()
    fig.savefig('n=2500,p=5000,linear.pdf')









